/*
	b0 			b7
	低    		高
	LED0	-	LED7
	0 1 1 1 1 1 1 1
	1 0 1 1 1 1 1 1
	1 1 0 1 1 1 1 1
	1 1 1 0 1 1 1 1
	1 1 1 1 0 1 1 1
	1 1 1 1 1 0 1 1
	1 1 1 1 1 1 0 1
	1 1 1 1 1 1 1 0

*/

#include "ai8051u.h" 			//调用头文件
#include "stc32_stc8_usb.h"		//USB CDC 头文件
#include "intrins.h"            //调用头文件

#define u8 unsigned char
#define u16 unsigned int


char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

u8 i = 0;

u8 State1 = 0;					//LED1初始状态为0
u8 State2 = 0;					//LED2初始状态为0
u8 State3 = 0;					//LED3初始状态为0

u8 State[9] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};

u8 num = 0;						//取值0-7
u16 Key_vol =0;					//按键维持时间
//u16 Count_300 = 0;				//计数300ms变量
//u16 Count_600 = 0;				//计数600ms变量
//u16 Count_900 = 0;				//计数900ms变量
u16 Count_ms[3] = { 0, 0, 0 };		//三个计时变量

void Timer0_Init(void);			//函数声明

void Delay10ms(void)	//@24.000MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 59998UL;
	while (i) i--;
}

void main (void)				//主函数
{  
	int count = 1;				//按键计数
	
    WTST = 0;  					//设置程序指令延时参数，赋值为0可将CPU执行指令的速度设置为最快
    EAXFR = 1; 					//扩展寄存器(XFR)访问使能
    CKCON = 0; 					//提高访问XRAM速度
	
	P_SW2 |= 0x80;              //B7位置1，使能访问XFR寄存器
	
	P0M0 = 0x00; P0M1 = 0x00; 	
    P1M0 = 0x00; P1M1 = 0x00; 
    P2M0 = 0x00; P2M1 = 0x00; 
    P3M0 = 0x00; P3M1 = 0x00; 
    P4M0 = 0x00; P4M1 = 0x00; 
    P5M0 = 0x00; P5M1 = 0x00; 
    P6M0 = 0x00; P6M1 = 0x00; 
    P7M0 = 0x00; P7M1 = 0x00; 	//将所有的端口都设置成准双向口，方便后期的使用。

	usb_init();					//USB CDC 接口配置
	
	IE2 |= 0x80;                //使能USB中断
	
	Timer0_Init();				//定时器初始化
	
    EA = 1; 					//EA |= 0X80;
	
	while (DeviceState != DEVSTATE_CONFIGURED);     //等待USB完成配置
	
    while (1)
    {
        if (bUsbOutReady)					//如果接收到了一个数据
        {
            //USB_SendData(UsbOutBuffer,OutNumber);   //发送数据缓冲区，长度（接收数据原样返回, 用于测试）		
//			printf("State数组原本的第一个数据为：%d\r\n", (int)State[0]);	//读取数组数据
//			State[0] = 2;					//给数组写入数据
//			printf("State数据修改后的第一个数据为：%d\r\n", (int)State[0]);
            usb_OUT_done();					//清除当前的接收区
        }

//		if( Count_ms[0] >= 500 )
//		{
//			Count_ms[0] = 0;
//			P0 = ~State[num];
//			printf("P0数值：%x\r\n", P0);
//			num ++;
//			if(num > 7)
//			{
//				num = 0;
//			}
//		}
		
		P0 = ~State[num];
		
//		if(P32 == 0)
//		{
//			Delay10ms();
//			if(P32 == 0)
//			{
//				while(P32 == 0);
//				num ++;
//				printf("P0数值：%x\r\n", P0);
//			}
//		}
		
		if(Count_ms[1] >= 1000)
		{
			Count_ms[1] = 0;
			printf("Ai8051U\r\n");
		}
		
		if(Count_ms[2] >= 10)			//按键持续按下50ms也会判定为按下按键,然后按一下加一下，实现了按键检测和串口打印的互不干扰。
		{
			Count_ms[2] = 0;
			if(P32 == 0)
			{
				Key_vol ++;
				if(Key_vol == 5)
				{
					num ++;
				}
				printf("num数值：%d\r\n", num);
			}
			else
			{
				Key_vol = 0;
			}
		}

	}
}
		
//		if(Count_300 >= 300)				//300MS达到
//		{
//			Count_300 = 0;
//			State1 = !State1;
//			P00 = State1;					//LED1取反
////			printf("P00 = %d\r\n",State1);
//		}
//		if(Count_600 >= 600)				//600MS达到
//		{
//			Count_600 = 0;
//			State2 = !State2;
//			P01 = State2;					//LED2取反
////			printf("P01 = %d\r\n",State2);
//		}
//		if(Count_900 >= 900)				//900MS达到
//		{
//			Count_900 = 0;
//			State3 = !State3;
//			P02 = State3;					//LED3取反
////			printf("P02 = %d\r\n",State3);
//		}

//	}
//}

//函数定义
void Timer0_Init(void)		//1毫秒@24.000MHz 24位自动重载
{
	TM0PS = 0x00;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	AUXR &= 0x7F;			//定时器时钟12T模式
	TMOD &= 0xF0;			//设置定时器模式
	TL0 = 0x30;				//设置定时初始值
	TH0 = 0xF8;				//设置定时初始值
	TF0 = 0;				//清除TF0标志
	TR0 = 1;				//定时器0开始计时
	ET0 = 1;				//使能定时器0中断
}

void Timer0_Isr(void) interrupt 1  			//1ms执行一次。
{
	for(i = 0; i < 3; i++)
	{
		Count_ms[i] ++;
	}
		
//		if(Count_ms[0] >= 300)
//		{
//			Count_ms[0] = 0;
//			State1 = !State1;
//			P00 = State1;					//LED1取反
//			printf("P00 = %d\r\n",State1);
//		}
////		printf("当前是State数组的第%d个数据%d\r\n", (int)i);
//	}
//	Count_300++;
//	Count_600++;
//	Count_900++;
	
}

		